clear all
tic
[NumData, TextData, AllData] = xlsread('CEMI.xlsx', 'CEMI_raw'); %input the file name and sheet name
NumData(isnan(NumData))=0;
t=NumData(:,1);
w=[8.259,8.253,8.2515,8.2515,8.253,8.2515,8.2545,8.2485];%total weight of the sample in g for normalisation
%w=[1 1 1 1 1 1 1 1];
C_1=NumData(:,3:4)./w(1);   %1
C_2=NumData(:,7:8)./w(2);  %2

C_3=NumData(:,11:12)./w(3);%3
C_4=NumData(:,15:16)./w(4);%4

C_5=NumData(:,19:20)./w(5);%5
C_6=NumData(:,23:24)./w(6);%6

C_7=NumData(:,27:28)./w(7);%7
C_8=NumData(:,31:32)./w(8);%8

%Phase alignment in time
C_1=align(C_1,t);
C_2=align(C_2,t);
C_3=align(C_3,t);
C_4=align(C_4,t);
C_5=align(C_5,t);
C_6=align(C_6,t);
C_7=align(C_7,t);
C_8=align(C_8,t);
%% Plot individual
% f1=figure; %Heatflow
% plot(C_1(:,1)/3600,C_1(:,2),'k', 'linewidth', 1.2);
% hold on
% plot(C_2(:,1)/3600,C_2(:,2),'k--', 'linewidth', 1.2);
% plot(C_3(:,1)/3600,C_3(:,2),'b', 'linewidth', 1.2);
% plot(C_4(:,1)/3600,C_4(:,2),'b--', 'linewidth', 1.2);
% plot(C_5(:,1)/3600,C_5(:,2),'g', 'linewidth', 1.2);
% plot(C_6(:,1)/3600,C_6(:,2),'g--', 'linewidth', 1.2);
% plot(C_7(:,1)/3600,C_7(:,2),'r', 'linewidth', 1.2);
% plot(C_8(:,1)/3600,C_8(:,2),'r--', 'linewidth', 1.2);
% xlabel('Time (hours)');
% ylabel('Heat flow rate normalised (W/g)');
% xlim([1, 168]);
% grid on
% title('CEMI 42.5N w/b=0.5')
% set(gca,'FontSize',14);
% legend('Control','0.01% FeCN', '0.1% FeCN', '1% FeCN','location','best','FontSize',14);
% saveas(f1,'CEMI_all_heatflow.png');
% 
% f2=figure %Heatflow
% plot(C_1(:,1)/3600,C_1(:,3),'k', 'linewidth', 1.2);
% hold on
% plot(C_2(:,1)/3600,C_2(:,3),'k--', 'linewidth', 1.2);
% plot(C_3(:,1)/3600,C_3(:,3),'b', 'linewidth', 1.2);
% plot(C_4(:,1)/3600,C_4(:,3),'b--', 'linewidth', 1.2);
% plot(C_5(:,1)/3600,C_5(:,3),'g', 'linewidth', 1.2);
% plot(C_6(:,1)/3600,C_6(:,3),'g--', 'linewidth', 1.2);
% plot(C_7(:,1)/3600,C_7(:,3),'r', 'linewidth', 1.2);
% plot(C_8(:,1)/3600,C_8(:,3),'r--', 'linewidth', 1.2);
% xlabel('Time (hours)');
% ylabel('Cumulative heat normalised (J/g)');
% xlim([0, 168]);
% grid on
% title('CEMI 42.5N w/b=0.5')
% set(gca,'FontSize',14)
% saveas(f2,'CEMI_all_heat_cumulative.png');

%% Mean
C_a(:,1)=mean([C_1(1:length(C_2),2),C_2(:,2)],2);
C_a(:,2)=mean([C_1(1:length(C_2),3),C_2(:,3)],2);

C_b(:,1)=mean([C_3(1:length(C_4),2),C_4(:,2)],2);
C_b(:,2)=mean([C_3(1:length(C_4),3),C_4(:,3)],2);

C_c(:,1)=mean([C_5(1:length(C_6),2),C_6(:,2)],2);
C_c(:,2)=mean([C_5(1:length(C_6),3),C_6(:,3)],2);

C_d(:,1)=mean([C_7(1:length(C_8),2),C_8(:,2)],2);
C_d(:,2)=mean([C_7(1:length(C_8),3),C_8(:,3)],2);


%Weight of binder for normalisation


%% Plot
% Heat flow
r=figure;

plot(C_2(:,1)/3600,C_a(:,1),'k','LineWidth',1);
hold on
plot(C_4(:,1)/3600,C_b(:,1),'r','LineWidth',1);
plot(C_6(:,1)/3600,C_c(:,1),'g','LineWidth',1);
plot(C_8(:,1)/3600,C_d(:,1),'b','LineWidth',1);

xlabel('Time (hours)');
ylabel('Rate of hydration [W/g]');
legend('Control','0.01% FeCN', '0.1% FeCN', '1% FeCN','location','best','FontSize',14);
grid on
xlim([1, 168]);
title('CEMI 42.5N, w/b=0.5')
set(gca,'FontSize',14)
saveas(r,'CEMI_mean_heat flow normalised.png');

% cumulative heat
s=figure;
plot(C_2(:,1)/3600,C_a(:,2),'k','LineWidth',1);
hold on
plot(C_4(:,1)/3600,C_b(:,2),'r','LineWidth',1);
plot(C_6(:,1)/3600,C_c(:,2),'g','LineWidth',1);
plot(C_8(:,1)/3600,C_d(:,2),'b','LineWidth',1);


xlim([0, 168]);
xlabel('Time (hours)');
ylabel('Cumulative heat of hydration [J/g]');
legend('Control','0.01% FeCN', '0.1% FeCN', '1% FeCN','location','best','FontSize',14);
grid on
title('CEMI 42.5N, w/b=0.5')
set(gca,'FontSize',14)
saveas(s,'CEMI_mean_cumulative heat normalised.png');
%%
function C_al=align(C,time)
ix=find(C(:,1)>0.0001,1,'first');
C=C(ix:end,:);
t=time(ix:end,1);
t=t-t(1);
C_al=[t,C];
end